#include "stack.h"

#include <stdlib.h>

void push(stack_t *s, void *p)
{
  if (s->size == s->maxsize) {
    s->maxsize += 4096;
    s->s = realloc(s->s, sizeof(void *) * s->maxsize); if (s->s == NULL) abort();
  }
  s->s[s->size] = p;
  s->size++;
}

void *pop(stack_t *s)
{
  void *ret = s->s[s->size - 1];
  s->size--;
  return ret;
}

void init_stack(stack_t *s)
{
  s->maxsize = 4096;
  s->size = 0;
  s->s = malloc(sizeof(void *) * s->maxsize); if (s->s == NULL) abort();
}

void free_stack(stack_t *s)
{
  free(s->s);
}

void free_stack_free_items(stack_t *s)
{
  for (int i = 0; i < s->size; i++) free(s->s[i]);
  free(s->s);
}
